## visad
Class FlowControl

    java.lang.Object
      visad.Control
          visad.FlowControl

All Implemented Interfaces:
  Cloneable, Serializable

Direct Known Subclasses:
  Flow1Control, Flow2Control

public abstract class FlowControl
extends Control

FlowControl is the VisAD abstract super-class for controlling Flow display scalars.

See Also:
  Serialized Form

Nested Class Summary
`(package private) class` `FlowControl.ProjectionControlListener` A class for listening to changes in the control.

Field Summary
`(package private) boolean` `adjustFlowToEarth`
`(package private) float` `arrowScale`
`(package private) int` `barbOrientation`
`(package private) float` `cntrWeight`
`(package private) float` `flowScale`
`(package private) boolean` `HorizontalStreamSlice`
`(package private) double` `HorizontalStreamSliceHeight`
`(package private) boolean` `HorizontalVectorSlice`
`(package private) double` `HorizontalVectorSliceHeight`
`(package private) int` `n_pass`
`static int` `NH_ORIENTATION` Northern Hemisphere orientation for wind barbs
`(package private) float` `packingFactor`
`(package private) float` `reduction`
`static int` `SH_ORIENTATION` Southern Hemisphere orientation for wind barbs
`(package private) float` `stepFactor`
`(package private) float` `streamlineDensity`
`(package private) boolean` `streamlinesEnabled` Streamline flags -------------------------------
`(package private) boolean[]` `TrajectorySet`
`(package private) boolean` `VerticalStreamSlice`
`(package private) boolean` `VerticalVectorSlice`

Fields inherited from class visad.Control
`display, displayRenderer`

Constructor Summary
`FlowControl(DisplayImpl d)` Create a FlowControl

Method Summary
`Object` `clone()` Clone this control.
`void` `enableStreamlines(boolean flag)` Enable/disable showing vectors as streamlines
`boolean` `equals(Object o)` See if this control equals another
`boolean` `getAdjustFlowToEarth()` Get barb orientation for wind barbs
`float` `getArrowScale()` Get the streamline arrow scale
`boolean` `getAutoScale()` Get whether the vector/barb size should scale with display zoom.
`int` `getBarbOrientation()` Get barb orientation for wind barbs
`float` `getFlowScale()` Get scale length for flow vectors
`String` `getSaveString()` Get a string that can be used to reconstruct this control later
`float` `getStepFactor()` Get the streamline step factor
`float` `getStreamlineDensity()` Get the streamline density factor.
`float` `getStreamlinePacking()` Get the streamline packing value
`float` `getStreamlineReduction()` Get the streamline reduction value
`float[]` `getStreamlineSmoothing()` Get the streamline smoothing value
`void` `nullControl()` Null the control.
`void` `setAdjustFlowToEarth(boolean adjust)` Get whether values should be adjusted to the earth
`void` `setArrowScale(float arrowScale)` Set the streamline arrow size
`void` `setAutoScale(boolean auto)` Set whether the vector/barb size should scale with display zoom.
`void` `setBarbOrientation(int orientation)` Set barb orientation for wind barbs (default is southern hemisphere)
`void` `setFlowScale(float scale)` Set scale length for flow vectors (default is 0.02f)
`void` `setSaveString(String save)` Reconstruct this control using the specified save string
`void` `setStepFactor(float stepFactor)` Set the streamline step factor
`void` `setStreamlineDensity(float density)` Set the streamline density
`void` `setStreamlinePacking(float packing)` Set the streamline packing
`void` `setStreamlineReduction(float reduction)` Set the streamline reduction
`void` `setStreamlineSmoothing(float cntrWeight, int n_pass)` Set the streamline smoothing
`boolean` `streamlinesEnabled()` Get the status of streamlines
`void` `syncControl(Control rmt)` Copy the state of a remote control to this control

Methods inherited from class visad.Control
`addControlListener, animation_string, changeControl, checkTicks, getDisplay, getDisplayRenderer, getIndex, getInstanceNumber, incTick, peekTicks, removeControlListener, resetTicks, setIndex, setInstanceNumber, setTicks, subCheckTicks, subPeekTicks, subResetTicks, subSetTicks, toString`

Methods inherited from class java.lang.Object
`finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### flowScale

    float flowScale

### NH_ORIENTATION

    public static final int NH_ORIENTATION

  Northern Hemisphere orientation for wind barbs

  See Also:
    Constant Field Values

### SH_ORIENTATION

    public static final int SH_ORIENTATION

  Southern Hemisphere orientation for wind barbs

  See Also:
    Constant Field Values

### barbOrientation

    int barbOrientation

### adjustFlowToEarth

    boolean adjustFlowToEarth

### HorizontalVectorSlice

    boolean HorizontalVectorSlice

### VerticalVectorSlice

    boolean VerticalVectorSlice

### HorizontalStreamSlice

    boolean HorizontalStreamSlice

### VerticalStreamSlice

    boolean VerticalStreamSlice

### TrajectorySet

    boolean[] TrajectorySet

### HorizontalVectorSliceHeight

    double HorizontalVectorSliceHeight

### HorizontalStreamSliceHeight

    double HorizontalStreamSliceHeight

### streamlinesEnabled

    boolean streamlinesEnabled

  Streamline flags -------------------------------

### streamlineDensity

    float streamlineDensity

### arrowScale

    float arrowScale

### stepFactor

    float stepFactor

### packingFactor

    float packingFactor

### cntrWeight

    float cntrWeight

### n_pass

    int n_pass

### reduction

    float reduction

Constructor Detail

### FlowControl

    public FlowControl(DisplayImpl d)

  Create a FlowControl

Parameters:
  `d` - DisplayImpl that this is associated with.

Method Detail

### setFlowScale

    public void setFlowScale(float scale)
                      throws VisADException,
                             RemoteException

  Set scale length for flow vectors (default is 0.02f)

  Parameters:
    `scale` - new scale
  Throws:
    `VisADException`
    `RemoteException`

### getFlowScale

    public float getFlowScale()

  Get scale length for flow vectors

  Returns:
    scale length for flow vectors

### setBarbOrientation

    public void setBarbOrientation(int orientation)
                            throws VisADException,
                                   RemoteException

  Set barb orientation for wind barbs (default is southern hemisphere)

  Parameters:
    `orientation` - wind barb orientation (NH_ORIENTATION or SH_ORIENTATION);
  Throws:
    `VisADException`
    `RemoteException`

### getBarbOrientation

    public int getBarbOrientation()

  Get barb orientation for wind barbs

  Returns:
    orientation (false = northern hemisphere)

### setAdjustFlowToEarth

    public void setAdjustFlowToEarth(boolean adjust)
                              throws VisADException,
                                     RemoteException

  Get whether values should be adjusted to the earth

  Parameters:
    `adjust` - true to adjust
  Throws:
    `VisADException` - problem setting the value
    `RemoteException` - problem setting the value on remote system

### getAdjustFlowToEarth

    public boolean getAdjustFlowToEarth()

  Get barb orientation for wind barbs

  Returns:
    orientation (false = northern hemisphere)

### enableStreamlines

    public void enableStreamlines(boolean flag)
                           throws VisADException,
                                  RemoteException

  Enable/disable showing vectors as streamlines

  Parameters:
    `flag` - true to display as streamlines
  Throws:
    `VisADException` - problem enabling the streamlines
    `RemoteException` - problem enabling the streamlines on remote system

### setStreamlineDensity

    public void setStreamlineDensity(float density)
                              throws VisADException,
                                     RemoteException

  Set the streamline density

  Parameters:
    `density` - the density value
  Throws:
    `VisADException` - problem setting the density
    `RemoteException` - problem setting the density on remote system

### setArrowScale

    public void setArrowScale(float arrowScale)
                       throws VisADException,
                              RemoteException

  Set the streamline arrow size

  Parameters:
    `arrowScale` - the streamline arrow size
  Throws:
    `VisADException` - problem setting the arrow scale
    `RemoteException` - problem setting the arrow scale on remote system

### setStepFactor

    public void setStepFactor(float stepFactor)
                       throws VisADException,
                              RemoteException

  Set the streamline step factor

  Parameters:
    `stepFactor` - the streamline step factor
  Throws:
    `VisADException` - problem setting the step factor
    `RemoteException` - problem setting the step factor on remote system

### setStreamlinePacking

    public void setStreamlinePacking(float packing)
                              throws VisADException,
                                     RemoteException

  Set the streamline packing

  Parameters:
    `packing` - the streamline packing
  Throws:
    `VisADException` - problem setting the packing
    `RemoteException` - problem setting the packing on remote system

### setStreamlineSmoothing

    public void setStreamlineSmoothing(float cntrWeight,
                                       int n_pass)
                                throws VisADException,
                                       RemoteException

  Set the streamline smoothing

  Parameters:
    `cntrWeight` - the center weight
    `n_pass` - number of smoothing passes
  Throws:
    `VisADException` - problem setting the smoothing
    `RemoteException` - problem setting the smoothing on remote system

### setStreamlineReduction

    public void setStreamlineReduction(float reduction)
                                throws VisADException,
                                       RemoteException

  Set the streamline reduction

  Parameters:
    `reduction` - the streamline reduction
  Throws:
    `VisADException` - problem setting the reduction
    `RemoteException` - problem setting the reduction on remote system

### streamlinesEnabled

    public boolean streamlinesEnabled()

  Get the status of streamlines

  Returns:
    true if streamlines are enabled.

### getStreamlineDensity

    public float getStreamlineDensity()

  Get the streamline density factor.

  Returns:
    the streamline density factor.

### getArrowScale

    public float getArrowScale()

  Get the streamline arrow scale

  Returns:
    the streamline arrow scale

### getStepFactor

    public float getStepFactor()

  Get the streamline step factor

  Returns:
    the streamline step factor

### getStreamlinePacking

    public float getStreamlinePacking()

  Get the streamline packing value

  Returns:
    the streamline packing value

### getStreamlineSmoothing

    public float[] getStreamlineSmoothing()

  Get the streamline smoothing value

  Returns:
    the streamline smoothing value

### getStreamlineReduction

    public float getStreamlineReduction()

  Get the streamline reduction value

  Returns:
    the streamline reduction value

### getSaveString

    public String getSaveString()

  Get a string that can be used to reconstruct this control later

  Specified by:
    `getSaveString` in class `Control`
  Returns:
    a string representation of this control

### setSaveString

    public void setSaveString(String save)
                       throws VisADException,
                              RemoteException

  Reconstruct this control using the specified save string

  Specified by:
    `setSaveString` in class `Control`
  Parameters:
    `save` - - String representation for reconstruction
  Throws:
    `VisADException` - if a VisAD error occurs
    `RemoteException` - if an RMI error occurs

### syncControl

    public void syncControl(Control rmt)
                     throws VisADException

  Copy the state of a remote control to this control

  Specified by:
    `syncControl` in class `Control`
  Parameters:
    `rmt` - remote Control whose state is copied
  Throws:
    `VisADException` - if a VisAD error occurs

### setAutoScale

    public void setAutoScale(boolean auto)
                      throws VisADException

  Set whether the vector/barb size should scale with display zoom.

  Parameters:
    `auto` - true to enable autoscaling.
  Throws:
    `VisADException` - problem setting the autoscaling

### getAutoScale

    public boolean getAutoScale()

  Get whether the vector/barb size should scale with display zoom.

  Returns:
    true if autoscaling is enabled.

### nullControl

    public void nullControl()

  Null the control. Override superclass to remove the autoscaling listener.

  Overrides:
    `nullControl` in class `Control`

### equals

    public boolean equals(Object o)

  See if this control equals another

  Overrides:
    `equals` in class `Control`
  Parameters:
    `o` - object in question
  Returns:
    true if they are equal.

### clone

    public Object clone()

  Clone this control.

  Overrides:
    `clone` in class `Control`
  Returns:
    a clone of this